CREATE OR REPLACE FORCE EDITIONABLE VIEW "IDM_RPT_DATA"."IDMRPT_RES_TRUST_V" ("RES_ID", "RES_NAME", "RES_DN", "RES_DESC", "IDMRPT_SYN_STATE", "ROLE_NAME", "IDV_NAME1", "LAST_NAME", "FIRST_NAME", "MIDDLE_INITIAL", "TRUST_START_TIME", "TRUST_EXPIRATION_TIME", "IDMRPT_VALID_TO", "IDMRPT_VALID_FROM", "IDENTITY_ID", "REQUESTER_ID", "TRUST_TYPE_ID", "IDM_RPT_DELETED", "ENT_DN", "ENT_NAME", "DRIVER_DN", "DRIVER_NAME", "FAKE_FUTURE_DATE", "ENT_VALUE", "IDV_ENT_ID", "LIID", "IDMRPT_RESOURCE_VALID_TO", "IDMRPT_IDENTITY_VALID_TO", "IDMRPT_IDENTITY_IDENTITY_ID", "ENT_IDMRPT_VALID_TO", "ENT_IDV_ENT_ID") AS 
 SELECT  
    idmrpt_resource.res_id,
    COALESCE(idmrpt_resource.res_name, idmrpt_resource.res_dn) AS res_name,
    idmrpt_resource.res_dn,
    idmrpt_resource.res_desc,
    idmrpt_resource.idmrpt_syn_state,
        CASE
            WHEN lower(to_char(idmrpt_idv_identity_trust.cause_type)) = lower(to_char('role driver')) THEN (to_char(rela.role_name) || to_char(' -- ')) || to_char(rela.role_descr)
            ELSE NULL
        END AS role_name,
        CASE
            WHEN trim(to_char(idmrpt_rpt_driver.idv_host)) = trim(to_char(idmrpt_rpt_driver.idv_name)) THEN to_char(idmrpt_rpt_driver.idv_name)
            ELSE ((to_char(idmrpt_rpt_driver.idv_name) || to_char(' (')) || to_char(idmrpt_rpt_driver.idv_host)) || to_char(')')
        END AS idv_name1,
    idmrpt_identity.last_name,
    idmrpt_identity.first_name,
    idmrpt_identity.middle_initial,
    idmrpt_idv_identity_trust.trust_start_time,
    idmrpt_idv_identity_trust.trust_expiration_time,
    idmrpt_idv_identity_trust.idmrpt_valid_to,
    idmrpt_idv_identity_trust.idmrpt_valid_from,
    idmrpt_idv_identity_trust.identity_id,
    idmrpt_idv_identity_trust.requester_id,
    idmrpt_idv_identity_trust.trust_type_id,
    idmrpt_idv_identity_trust.idmrpt_deleted AS idm_rpt_deleted,
    ent.idmrpt_ent_dn ent_dn,
    ent.idmrpt_ent_name ent_name,
    driver.drv_dn driver_dn,
    driver.drv_name driver_name,
    TO_CHAR(CURRENT_TIMESTAMP + '7305', 'yyyy-mm-dd hh:mm:ss') fake_future_date,
        CASE
            WHEN to_char(bind_v.ent_param_str) LIKE to_char('%ID2%') THEN ( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
               FROM idm_rpt_data.idmrpt_ms_ent_cs_v
              WHERE to_char(idmrpt_ms_ent_cs_v.ms_ent_val) = SUBSTR(to_char(bind_v.ent_param_str), INSTR(to_char(bind_v.ent_param_str), to_char('ID2')) + 6, INSTR(SUBSTR(to_char(bind_v.ent_param_str), INSTR(to_char(bind_v.ent_param_str), to_char('ID2')) + 6), to_char('}')) - 2))
            WHEN to_char(bind_v.ent_param_str) LIKE to_char('%ID%') THEN ( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
               FROM idm_rpt_data.idmrpt_ms_ent_cs_v
              WHERE to_char(idmrpt_ms_ent_cs_v.ms_ent_val) = SUBSTR(to_char(bind_v.ent_param_str), INSTR(to_char(bind_v.ent_param_str), to_char('ID')) + 5, INSTR(SUBSTR(to_char(bind_v.ent_param_str), INSTR(to_char(bind_v.ent_param_str), to_char('ID')) + 5), to_char('}')) - 2))
            WHEN to_char(bind_v.ent_param_str) = to_char('%EntitlementParamKey%') OR to_char(bind_v.ent_param_val) = to_char('%EntitlementParamKey%') THEN
            CASE
                WHEN to_char(idmrpt_idv_identity_trust.trust_params) LIKE to_char('%ID2%') THEN to_char((( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
                   FROM idm_rpt_data.idmrpt_ms_ent_cs_v
                  WHERE to_char(idmrpt_ms_ent_cs_v.ms_ent_val) = SUBSTR(to_char(idmrpt_idv_identity_trust.trust_params), INSTR(to_char(idmrpt_idv_identity_trust.trust_params), to_char('ID2')) + 6, INSTR(SUBSTR(to_char(idmrpt_idv_identity_trust.trust_params), INSTR(to_char(idmrpt_idv_identity_trust.trust_params), to_char('ID2')) + 6), to_char('}')) - 2))))
                WHEN to_char(idmrpt_idv_identity_trust.trust_params) LIKE to_char('%ID%') THEN to_char((( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
                   FROM idm_rpt_data.idmrpt_ms_ent_cs_v
                  WHERE to_char(idmrpt_ms_ent_cs_v.ms_ent_val) = SUBSTR(to_char(idmrpt_idv_identity_trust.trust_params), INSTR(to_char(idmrpt_idv_identity_trust.trust_params), to_char('ID')) + 5, INSTR(SUBSTR(to_char(idmrpt_idv_identity_trust.trust_params), INSTR(to_char(idmrpt_idv_identity_trust.trust_params), to_char('ID')) + 5), to_char('}')) - 2))))
                ELSE SUBSTR(to_char(idmrpt_idv_identity_trust.trust_params), INSTR(to_char(idmrpt_idv_identity_trust.trust_params), to_char('EntitlementParamKey')) + 21, INSTR(SUBSTR(to_char(idmrpt_idv_identity_trust.trust_params), INSTR(to_char(idmrpt_idv_identity_trust.trust_params), to_char('EntitlementParamKey')) + 21), to_char('</value>')) - 1)
            END
            ELSE bind_v.ent_param_val
        END ent_value,
    ent.idv_ent_id,
    bind_v.ent_param_liid liid,
    idmrpt_resource.idmrpt_valid_to idmrpt_resource_valid_to,
    idmrpt_identity.idmrpt_valid_to idmrpt_identity_valid_to,
    idmrpt_identity.identity_id  idmrpt_identity_identity_id,
    ent.idmrpt_valid_to ent_idmrpt_valid_to,
    ent.idv_ent_id ent_idv_ent_id
   FROM idm_rpt_data.idmrpt_rpt_driver_v idmrpt_rpt_driver,
    idm_rpt_data.idmrpt_idv_v idmrpt_idv,
    idm_rpt_data.idmrpt_identity_v idmrpt_identity,
    idm_rpt_data.idmrpt_idv_identity_trust_v idmrpt_idv_identity_trust,
    idm_rpt_data.idmrpt_resource_v idmrpt_resource
     LEFT JOIN idm_rpt_data.idmrpt_idv_ent_bindings_v bind_v ON to_char(bind_v.cat_item_id) = to_char(idmrpt_resource.res_id)
     LEFT JOIN idm_rpt_data.idmrpt_idv_ent_v ent ON to_char(bind_v.ent_id) = to_char(ent.idv_ent_id)
     LEFT JOIN idm_rpt_data.idmrpt_idv_drivers_v driver ON to_char(ent.idv_driver_id) = to_char(driver.idv_driver_id)
     LEFT JOIN idm_rpt_data.idmrpt_r_to_res_relationship_v rela ON to_char(idmrpt_resource.res_id) = to_char(rela.res_id)
  WHERE to_char(idmrpt_resource.res_id) = to_char(idmrpt_idv_identity_trust.trust_obj_id) AND to_char(idmrpt_rpt_driver.idv_id) = to_char(idmrpt_idv.idv_id) AND
        CASE
            WHEN idmrpt_resource.rpt_drv_id IS NULL 
            THEN 1
            WHEN to_char(idmrpt_rpt_driver.rpt_drv_id) = to_char(idmrpt_resource.rpt_drv_id)
            THEN 1 
            ELSE 0
        END = 1  AND to_char(idmrpt_idv.idv_id) = to_char(idmrpt_resource.idv_id) AND to_char(idmrpt_idv_identity_trust.identity_id) = to_char(idmrpt_identity.identity_id) AND idmrpt_idv_identity_trust.trust_status = 1 AND
        CASE
            WHEN lower(to_char(idmrpt_idv_identity_trust.cause_type)) = lower(to_char('role driver')) 
            THEN (( SELECT count(1) AS count
               FROM idm_rpt_data.idmrpt_idv_identity_trust_v identity_trust
              WHERE to_char(identity_trust.trust_obj_id) = to_char(rela.role_id) AND to_char(identity_trust.identity_id) = to_char(idmrpt_idv_identity_trust.identity_id)))
            ELSE 1
        END = 1
  ORDER BY (COALESCE(idmrpt_resource.res_name, idmrpt_resource.res_dn)), (
        CASE
            WHEN lower(to_char(idmrpt_idv_identity_trust.cause_type)) = lower(to_char('role driver')) THEN (to_char(rela.role_name) || to_char(' -- ')) || to_char(rela.role_descr)
            ELSE NULL
        END), idmrpt_idv_identity_trust.trust_start_time, idmrpt_idv_identity_trust.idmrpt_valid_to, driver.drv_name, 
        (
        CASE
            WHEN to_char(bind_v.ent_param_str) LIKE to_char('%ID2%') THEN ( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
               FROM idm_rpt_data.idmrpt_ms_ent_cs_v
              WHERE to_char(idmrpt_ms_ent_cs_v.ms_ent_val) = SUBSTR(to_char(bind_v.ent_param_str), INSTR(to_char(bind_v.ent_param_str), to_char('ID2')) + 6, INSTR(SUBSTR(to_char(bind_v.ent_param_str), INSTR(to_char(bind_v.ent_param_str), to_char('ID2')) + 6), to_char('}')) - 2))
            WHEN to_char(bind_v.ent_param_str) LIKE to_char('%ID%') THEN ( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
               FROM idm_rpt_data.idmrpt_ms_ent_cs_v
              WHERE to_char(idmrpt_ms_ent_cs_v.ms_ent_val) = SUBSTR(to_char(bind_v.ent_param_str), INSTR(to_char(bind_v.ent_param_str), to_char('ID')) + 5, INSTR(SUBSTR(to_char(bind_v.ent_param_str), INSTR(to_char(bind_v.ent_param_str), to_char('ID')) + 5), to_char('}')) - 2))
            WHEN to_char(bind_v.ent_param_str) = to_char('%EntitlementParamKey%') OR to_char(bind_v.ent_param_val) = to_char('%EntitlementParamKey%') THEN
            CASE
                WHEN to_char(idmrpt_idv_identity_trust.trust_params) LIKE to_char('%ID2%') THEN to_char((( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
                   FROM idm_rpt_data.idmrpt_ms_ent_cs_v
                  WHERE to_char(idmrpt_ms_ent_cs_v.ms_ent_val) = SUBSTR(to_char(idmrpt_idv_identity_trust.trust_params), INSTR(to_char(idmrpt_idv_identity_trust.trust_params), to_char('ID2')) + 6, INSTR(SUBSTR(to_char(idmrpt_idv_identity_trust.trust_params), INSTR(to_char(idmrpt_idv_identity_trust.trust_params), to_char('ID2')) + 6), to_char('}')) - 2))))
                WHEN to_char(idmrpt_idv_identity_trust.trust_params) LIKE to_char('%ID%') THEN to_char((( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
                   FROM idm_rpt_data.idmrpt_ms_ent_cs_v
                  WHERE to_char(idmrpt_ms_ent_cs_v.ms_ent_val) = SUBSTR(to_char(idmrpt_idv_identity_trust.trust_params), INSTR(to_char(idmrpt_idv_identity_trust.trust_params), to_char('ID')) + 5, INSTR(SUBSTR(to_char(idmrpt_idv_identity_trust.trust_params), INSTR(to_char(idmrpt_idv_identity_trust.trust_params), to_char('ID')) + 5), to_char('}')) - 2))))
                ELSE SUBSTR(to_char(idmrpt_idv_identity_trust.trust_params), INSTR(to_char(idmrpt_idv_identity_trust.trust_params), to_char('EntitlementParamKey')) + 21, INSTR(SUBSTR(to_char(idmrpt_idv_identity_trust.trust_params), INSTR(to_char(idmrpt_idv_identity_trust.trust_params), to_char('EntitlementParamKey')) + 21), to_char('</value>')) - 1)
            END
            ELSE bind_v.ent_param_val
        END),
        bind_v.ent_param_liid, idmrpt_identity.last_name, idmrpt_identity.first_name, idmrpt_identity.middle_initial;
        
GRANT SELECT ON IDM_RPT_DATA.IDMRPT_RES_TRUST_V TO idmrptuser;
CREATE OR REPLACE PUBLIC SYNONYM IDMRPT_RES_TRUST_V for IDM_RPT_DATA.IDMRPT_RES_TRUST_V; 