 CREATE OR REPLACE VIEW idm_rpt_data.idmrpt_role_cs_summary_v AS 
 SELECT idmrpt_role.idmrpt_valid_from,
    idmrpt_role.idmrpt_valid_to,
    idmrpt_role.role_id,
        CASE
            WHEN trim(idmrpt_rpt_driver.idv_host) = trim(idmrpt_rpt_driver.idv_name) THEN idmrpt_rpt_driver.idv_name
            ELSE ((idmrpt_rpt_driver.idv_name || ' (') || idmrpt_rpt_driver.idv_host) || ')'
        END AS idv_name,
        CASE
            WHEN trim(idmrpt_role.role_name) = '' THEN idmrpt_role.role_dn
            ELSE idmrpt_role.role_name
        END AS role_name,
    idmrpt_role.role_desc,
    TO_CHAR(CURRENT_TIMESTAMP + '7305', 'yyyy-mm-dd hh:mm:ss')  fake_future_date
   FROM idm_rpt_data.idmrpt_rpt_driver_v idmrpt_rpt_driver,
    idm_rpt_data.idmrpt_idv_v idmrpt_idv,
    idm_rpt_data.idmrpt_role_cs_v idmrpt_role
  WHERE idmrpt_rpt_driver.idv_id = idmrpt_idv.idv_id AND idmrpt_idv.idv_id = idmrpt_role.idv_id AND
        CASE
            WHEN idmrpt_role.rpt_drv_id IS NULL THEN 1
            WHEN idmrpt_rpt_driver.rpt_drv_id = idmrpt_role.rpt_drv_id THEN 1
            ELSE 0
        END = 1
  ORDER BY (
        CASE
            WHEN trim(idmrpt_rpt_driver.idv_host) = trim(idmrpt_rpt_driver.idv_name) THEN idmrpt_rpt_driver.idv_name
            ELSE ((idmrpt_rpt_driver.idv_name || ' (') || idmrpt_rpt_driver.idv_host) || ')'
        END), (
        CASE
            WHEN trim(idmrpt_role.role_name) = '' THEN idmrpt_role.role_dn
            ELSE idmrpt_role.role_name
        END), idmrpt_role.idmrpt_valid_from;

GRANT SELECT ON IDM_RPT_DATA.idmrpt_role_cs_summary_v TO idmrptuser;
CREATE OR REPLACE PUBLIC SYNONYM idmrpt_role_cs_summary_v for IDM_RPT_DATA.idmrpt_role_cs_summary_v;