CREATE OR REPLACE VIEW idm_rpt_data.idmrpt_corr_res_assignment_v AS 
 SELECT sentinel_events.id AS event_id,
    sentinel_events.evt AS event_name,
    sentinel_events.msg AS base_message,
    sentinel_events.dt AS event_datetime,
    sentinel_events.sun AS source_user_name,
    sentinel_events.dun AS destination_user_name,
    sentinel_events.fn AS filename,
    sentinel_events.rv45,
    sentinel_events.rv36,
    sentinel_events.rv43,
    sentinel_events.ei AS extended_info,
    sentinel_events.iuid AS init_user_id,
    sentinel_events.agent,
        CASE
            WHEN sentinel_events.agent::text ~~ (('%'::text || 'NetIQ Modular Authentication Services'::text) || '%'::text) THEN
            CASE
                WHEN sentinel_events.evt::text ~~ '%LSM%'::text THEN ((('\'::text || rtrim("substring"("substring"("substring"(sentinel_events.ei::text, "position"(sentinel_events.ei::text, 'Target:'::text) + 12), 0, "position"("substring"(sentinel_events.ei::text, "position"(sentinel_events.ei::text, 'Target:'::text) + 12), ','::text) - 1), "position"("substring"("substring"(sentinel_events.ei::text, "position"(sentinel_events.ei::text, 'Target:'::text) + 12), 0, "position"("substring"(sentinel_events.ei::text, "position"(sentinel_events.ei::text, 'Target:'::text) + 12), ','::text) - 1), '.O='::text) + 3), ' '::text)) || '\'::text) || "substring"("substring"("substring"("substring"(sentinel_events.ei::text, "position"(sentinel_events.ei::text, 'Target:'::text) + 12), 0, "position"("substring"(sentinel_events.ei::text, "position"(sentinel_events.ei::text, 'Target:'::text) + 12), ','::text) - 1), "position"("substring"("substring"(sentinel_events.ei::text, "position"(sentinel_events.ei::text, 'Target:'::text) + 12), 0, "position"("substring"(sentinel_events.ei::text, "position"(sentinel_events.ei::text, 'Target:'::text) + 12), ','::text) - 1), 'OU='::text) + 3), 0, "position"("substring"("substring"("substring"(sentinel_events.ei::text, "position"(sentinel_events.ei::text, 'Target:'::text) + 12), 0, "position"("substring"(sentinel_events.ei::text, "position"(sentinel_events.ei::text, 'Target:'::text) + 12), ','::text) - 1), "position"("substring"("substring"(sentinel_events.ei::text, "position"(sentinel_events.ei::text, 'Target:'::text) + 12), 0, "position"("substring"(sentinel_events.ei::text, "position"(sentinel_events.ei::text, 'Target:'::text) + 12), ','::text) - 1), 'OU='::text) + 3), '.O='::text)))::character varying
                ELSE sentinel_events.rv36
            END
            ELSE
            CASE
                WHEN sentinel_events.rv45 IS NULL THEN sentinel_events.rv36
                ELSE
                CASE
                    WHEN sentinel_events.rv45::text ~~ ('%cn=%'::text || 'o=%'::text) THEN ((('\'::text || split_part(sentinel_events.rv45::text, '='::text, 4)) || '\'::text) || split_part(split_part(sentinel_events.rv45::text, ','::text, 2), '='::text, 2))::character varying
                    ELSE sentinel_events.rv45
                END
            END
        END AS target_user_domain,
    COALESCE(sentinel_events.iuid, sentinel_events.sun) AS acting_identity,
    split_part(split_part(sentinel_events.msg::text, 'Correlation ID: '::text, 2), ';'::text, 1) AS correlation_id,
    split_part(split_part(sentinel_events.msg::text, ';'::text, 3), ':'::text, 2) AS resource_msg
   FROM sentinel_events;

ALTER TABLE idm_rpt_data.idmrpt_corr_res_assignment_v
  OWNER TO idm_rpt_data;
GRANT ALL ON TABLE idm_rpt_data.idmrpt_corr_res_assignment_v TO idm_rpt_data;
GRANT SELECT ON TABLE idm_rpt_data.idmrpt_corr_res_assignment_v TO idmrptuser;
