-- View: idm_rpt_data.idmrpt_object_prov_v

-- DROP VIEW idm_rpt_data.idmrpt_object_prov_v;

CREATE OR REPLACE VIEW idm_rpt_data.idmrpt_object_prov_v AS 
 SELECT sentinel_events.id AS event_id,
    sentinel_events.evt AS event_name,
    sentinel_events.dt AS event_datetime,
    sentinel_events.sun AS source_user_name,
    sentinel_events.dun AS destination_user_name,
    sentinel_events.fn AS filename,
    sentinel_events.rv36,
    sentinel_events.isvcc AS init_service_comp,
    sentinel_events.iuid AS init_user_id,
    sentinel_events.dhn AS target_host_name,
    sentinel_events.dip AS target_ip_dotted,
    sentinel_events.ttd AS target_trust_domain,
    sentinel_events.ttn AS target_trust_name,
    sentinel_events.agent,
    sentinel_events.xdastaxname AS xdas_taxonomy_name,
    sentinel_events.xdasoutcomename AS xdas_outcome_name,
    (sentinel_events.xdastaxname::text || ' '::text) || sentinel_events.xdasoutcomename::text AS taxonomy_group
   FROM sentinel_events
  WHERE NOT (sentinel_events.fn IS NULL AND sentinel_events.dun IS NULL AND sentinel_events.ttn IS NULL) AND (sentinel_events.agent::text ~~ (('%'::text || 'Identity Manager'::text) || '%'::text) OR sentinel_events.agent::text ~~ (('%'::text || 'Modular Authentication Services'::text) || '%'::text) OR sentinel_events.agent::text ~~ (('%'::text || 'iManager'::text) || '%'::text)) AND (sentinel_events.xdastaxname::text = 'XDAS_AE_ASSOC_TRUST'::text OR sentinel_events.xdastaxname::text = 'XDAS_AE_GRANT_ACCOUNT_ACCESS'::text OR sentinel_events.xdastaxname::text = 'XDAS_AE_REVOKE_ACCOUNT_ACCESS'::text OR sentinel_events.xdastaxname::text = 'XDAS_AE_DEASSOC_TRUST'::text) AND (sentinel_events.xdasoutcomename::text = 'XDAS_OUT_SUCCESS'::text OR sentinel_events.xdasoutcomename::text = 'XDAS_OUT_FAILURE'::text) AND NOT sentinel_events.rv43 IS NULL;

ALTER TABLE idm_rpt_data.idmrpt_object_prov_v
  OWNER TO idm_rpt_data;
GRANT ALL ON TABLE idm_rpt_data.idmrpt_object_prov_v TO idm_rpt_data;
GRANT SELECT ON TABLE idm_rpt_data.idmrpt_object_prov_v TO idmrptuser;
